create or replace PROCEDURE GRS_LIMPEZA_TAB_ESPEC
AS
V_ERR0R              VARCHAR2(2000);
V_PASSO              NUMBER := 0;
V_NRORDEM            VARCHAR2(03);
V_DSIP               VARCHAR2(50);
V_DSUSUARIO          VARCHAR2(50);
V_DSRDM              VARCHAR2(50);
V_DSMETODO           VARCHAR2(250);
V_DSOPERADOR         VARCHAR2(12);
V_COUNT_COMMIT       NUMBER := 1;
V_NUM_TO_COMMIT      NUMBER := 10; -- NUMERO UTILIZADO PARA REGULARIZAR A QUANTIDADE DE DML´S PARA O COMMIT.
V_CDFILIAL           VARCHAR2(4);
V_EXCLUINF_SAP       NUMBER := 0;
V_EXCLUI_TG          NUMBER := 0;
V_EXCLUI_TI          NUMBER := 0;
V_EXUSR_SAP_AF       NUMBER := 0;

V_DTHRFINLIMPEZA     DATE;
V_DTINICIAL          DATE;
V_DTFINAL            DATE;

V_DTINICIALTI        VARCHAR2(08);
V_DTFINALTI          VARCHAR2(08);

   CURSOR C_LISTA IS (SELECT CDFILIAL
                        FROM TRABLIMPFILIAL
                       WHERE IDLIMPEZA = 'GER');

   PROCEDURE VerifTimeOut(DTLIMITE IN DATE)
   IS
   BEGIN
      IF SYSDATE > DTLIMITE THEN
         COMMIT;
         RAISE_APPLICATION_ERROR(-20001,'TIMEOUT - EXCECAO PROPOSITAL TEKNISA');
      END IF;
   END;
BEGIN
   V_DTINICIAL := TO_DATE('01/01/1990');
   V_DTINICIALTI := '19900101';

   --PEGA A DATA INICIAL E FINAL DA EXECUO
   SELECT TO_DATE(TO_CHAR(SYSDATE,'DDMMYYYY') || HRFINLIMPEZA||'00','DDMMYYYYHH24MISS'), TRUNC(TRABLIMPEZA.DTLIMPDADOSATE)
     INTO V_DTHRFINLIMPEZA, V_DTFINAL
     FROM TRABLIMPEZA
    WHERE IDLIMPEZA = 'GER';

   V_DTFINALTI := TO_CHAR(V_DTFINAL, 'YYYY') || TO_CHAR(V_DTFINAL, 'MM') || TO_CHAR(V_DTFINAL, 'DD');

   IF V_DTHRFINLIMPEZA <= SYSDATE THEN
      V_DTHRFINLIMPEZA := V_DTHRFINLIMPEZA + 1;
   END IF;

   DELETE FROM TRABPROCLIMPEZA
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP IN ('USR_SAP_NOTAFISCAL', 'EXPORTACAOTG', 'EXPORTACAOTI', 'USR_SAP_AUTOFORNE');

   V_NRORDEM := '0';

   UPDATE TRABLIMPEZA
      SET IDSTATUSLIMPEZA = 'A'
    WHERE IDLIMPEZA = 'GER';

   COMMIT;

    WEBTUNNING(V_DSIP, V_DSUSUARIO, V_DSRDM, V_DSMETODO,  V_DSOPERADOR);

   V_NRORDEM := LPAD(TO_CHAR(TO_NUMBER(V_NRORDEM)+1), 3, '0');

   UPDATE TABLIMPEZA
      SET NRORDEMLIMPEZA = V_NRORDEM
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP = 'USR_SAP_NOTAFISCAL';

   IF NOT(SQL%ROWCOUNT > 0) THEN
      INSERT INTO TABLIMPEZA
         (IDLIMPEZA, NMTABELALIMP, NRORDEMLIMPEZA)      
      VALUES
         ('GER', 'USR_SAP_NOTAFISCAL', V_NRORDEM);
   END IF;

   INSERT INTO TRABPROCLIMPEZA
      (IDLIMPEZA, NMTABELALIMP)
   VALUES
      ('GER', 'USR_SAP_NOTAFISCAL');

   V_NRORDEM := LPAD(TO_CHAR(TO_NUMBER(V_NRORDEM)+1), 3, '0');

   UPDATE TABLIMPEZA
      SET NRORDEMLIMPEZA = V_NRORDEM
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP = 'EXPORTACAOTG';

   IF NOT(SQL%ROWCOUNT > 0) THEN
      INSERT INTO TABLIMPEZA
         (IDLIMPEZA, NMTABELALIMP, NRORDEMLIMPEZA)      
      VALUES
         ('GER', 'EXPORTACAOTG', V_NRORDEM);
   END IF;

   INSERT INTO TRABPROCLIMPEZA
      (IDLIMPEZA, NMTABELALIMP)
   VALUES
      ('GER', 'EXPORTACAOTG');

   V_NRORDEM := LPAD(TO_CHAR(TO_NUMBER(V_NRORDEM)+1), 3, '0');

   UPDATE TABLIMPEZA
      SET NRORDEMLIMPEZA = V_NRORDEM
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP = 'EXPORTACAOTI';

   IF NOT(SQL%ROWCOUNT > 0) THEN
      INSERT INTO TABLIMPEZA
         (IDLIMPEZA, NMTABELALIMP, NRORDEMLIMPEZA)
      VALUES
         ('GER', 'EXPORTACAOTI', V_NRORDEM);
   END IF;

   INSERT INTO TRABPROCLIMPEZA
      (IDLIMPEZA, NMTABELALIMP)
   VALUES
      ('GER', 'EXPORTACAOTI');

   V_NRORDEM := LPAD(TO_CHAR(TO_NUMBER(V_NRORDEM)+1), 3, '0');

   UPDATE TABLIMPEZA
      SET NRORDEMLIMPEZA = V_NRORDEM
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP = 'USR_SAP_AUTOFORNE';

   IF NOT(SQL%ROWCOUNT > 0) THEN
      INSERT INTO TABLIMPEZA
         (IDLIMPEZA, NMTABELALIMP, NRORDEMLIMPEZA)
      VALUES
         ('GER', 'USR_SAP_AUTOFORNE', V_NRORDEM);
   END IF;

   INSERT INTO TRABPROCLIMPEZA
      (IDLIMPEZA, NMTABELALIMP)
   VALUES
      ('GER', 'USR_SAP_AUTOFORNE');

  /* COLOCA O STATUS DA TABELA DE LIMPEZA PARA ANDAMENTO */
   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP = 'A'
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP = 'USR_SAP_NOTAFISCAL';

   COMMIT;
   VERIFTIMEOUT(V_DTHRFINLIMPEZA);

   BEGIN
      EXECUTE IMMEDIATE 'TRUNCATE TABLE USR_SAP_LOG';
   EXCEPTION
      WHEN OTHERS THEN NULL;
   END;

   V_PASSO := 0;

   OPEN C_LISTA;
   LOOP
      FETCH C_LISTA INTO V_CDFILIAL;
      EXIT WHEN C_LISTA%NOTFOUND;

      FOR C_NOTAFISCAL IN (SELECT ROWID, CDUNICO
                             FROM USR_SAP_NOTAFISCAL
                            WHERE CDFILIAL  = V_CDFILIAL AND
                                  IDENTRSAID = 'E'       AND
                                  DTENTRADA BETWEEN V_DTINICIAL AND V_DTFINAL
                            UNION ALL
                           SELECT  ROWID, CDUNICO
                             FROM USR_SAP_NOTAFISCAL
                            WHERE CDFILIAL  = V_CDFILIAL AND
                                  IDENTRSAID = 'S'       AND
                                  DTENTRADA BETWEEN V_DTINICIAL AND V_DTFINAL)
      LOOP
         FOR C_DEL IN (SELECT ROWID
                         FROM USR_SAP_DADOSADIC
                        WHERE CDUNICO = C_NOTAFISCAL.CDUNICO)
         LOOP
            DELETE USR_SAP_DADOSADIC
             WHERE ROWID = C_DEL.ROWID;

            V_EXCLUINF_SAP := SQL%ROWCOUNT + V_EXCLUINF_SAP;

            IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN

               /*CONTROLE DE COMMIT HA CADA 1000 REGISTRO DELETEDO  E PARA ATUALIZAR A TELA DE LIMPEZA*/
               V_COUNT_COMMIT:= 1;
               COMMIT;
            ELSE
               V_COUNT_COMMIT:= V_COUNT_COMMIT + 1;
            END IF;
            /*Verifica se a procedure estourou o tempo limite*/
            VERIFTIMEOUT(V_DTHRFINLIMPEZA);
         END LOOP;

         FOR C_DEL IN (SELECT ROWID
                         FROM USR_SAP_VENCIMENTOS
                        WHERE CDUNICO = C_NOTAFISCAL.CDUNICO)
         LOOP
            DELETE USR_SAP_VENCIMENTOS
             WHERE ROWID = C_DEL.ROWID;

            V_EXCLUINF_SAP := SQL%ROWCOUNT + V_EXCLUINF_SAP;

            IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN

               /*CONTROLE DE COMMIT HA CADA 1000 REGISTRO DELETEDO  E PARA ATUALIZAR A TELA DE LIMPEZA*/
               V_COUNT_COMMIT:= 1;
               COMMIT;
            ELSE
               V_COUNT_COMMIT:= V_COUNT_COMMIT + 1;
            END IF;
            /*Verifica se a procedure estourou o tempo limite*/
            VERIFTIMEOUT(V_DTHRFINLIMPEZA);
         END LOOP;

         FOR C_DEL IN (SELECT ROWID
                         FROM USR_SAP_ITEMENCARGO
                        WHERE CDUNICO = C_NOTAFISCAL.CDUNICO)
         LOOP
            DELETE USR_SAP_ITEMENCARGO
             WHERE ROWID = C_DEL.ROWID;

            V_EXCLUINF_SAP := SQL%ROWCOUNT + V_EXCLUINF_SAP;

            IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN

               /*CONTROLE DE COMMIT HA CADA 1000 REGISTRO DELETEDO  E PARA ATUALIZAR A TELA DE LIMPEZA*/
               V_COUNT_COMMIT:= 1;
               COMMIT;
            ELSE
               V_COUNT_COMMIT:= V_COUNT_COMMIT + 1;
            END IF;
            /*Verifica se a procedure estourou o tempo limite*/
            VERIFTIMEOUT(V_DTHRFINLIMPEZA);
         END LOOP;

         FOR C_DEL IN (SELECT ROWID
                         FROM USR_SAP_ITEMPROIMPOS
                        WHERE CDUNICO = C_NOTAFISCAL.CDUNICO)
         LOOP
             DELETE USR_SAP_ITEMPROIMPOS
              WHERE ROWID = C_DEL.ROWID;

             V_EXCLUINF_SAP := SQL%ROWCOUNT + V_EXCLUINF_SAP;

             IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN

                /*CONTROLE DE COMMIT HA CADA 1000 REGISTRO DELETEDO  E PARA ATUALIZAR A TELA DE LIMPEZA*/
                V_COUNT_COMMIT:= 1;
                COMMIT;
             ELSE
                V_COUNT_COMMIT:= V_COUNT_COMMIT + 1;
             END IF;
             /*Verifica se a procedure estourou o tempo limite*/
             VERIFTIMEOUT(V_DTHRFINLIMPEZA);
         END LOOP;

         FOR C_DEL IN (SELECT ROWID
                         FROM USR_SAP_ITEMPRODUTO
                        WHERE CDUNICO = C_NOTAFISCAL.CDUNICO)
         LOOP
             DELETE USR_SAP_ITEMPRODUTO
              WHERE ROWID = C_DEL.ROWID;

             V_EXCLUINF_SAP := SQL%ROWCOUNT + V_EXCLUINF_SAP;

             IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN

                /*CONTROLE DE COMMIT HA CADA 1000 REGISTRO DELETEDO  E PARA ATUALIZAR A TELA DE LIMPEZA*/
                V_COUNT_COMMIT:= 1;
                COMMIT;
             ELSE
                V_COUNT_COMMIT:= V_COUNT_COMMIT + 1;
             END IF;
             /*Verifica se a procedure estourou o tempo limite*/
             VERIFTIMEOUT(V_DTHRFINLIMPEZA);
         END LOOP;

         DELETE USR_SAP_NOTAFISCAL
          WHERE ROWID = C_NOTAFISCAL.ROWID;

         V_EXCLUINF_SAP := SQL%ROWCOUNT + V_EXCLUINF_SAP;

         IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN

            /*CONTROLE DE COMMIT HA CADA 1000 REGISTRO DELETEDO  E PARA ATUALIZAR A TELA DE LIMPEZA*/
            V_COUNT_COMMIT:= 1;
            COMMIT;
         ELSE
            V_COUNT_COMMIT:= V_COUNT_COMMIT + 1;
         END IF;
         /*Verifica se a procedure estourou o tempo limite*/
         VERIFTIMEOUT(V_DTHRFINLIMPEZA);
      END LOOP;
   END LOOP;
   CLOSE C_LISTA;

   V_PASSO := 1;

   /* COLOCA O STATUS DA TABELA DE LIMPEZA PARA CONCLUIDO */
   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP = 'C',
          QTREGEXCLIMPEZA = V_EXCLUINF_SAP,
          DTHRFINLIMPEZA = SYSDATE
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP = 'USR_SAP_NOTAFISCAL';

   /* COLOCA O STATUS DA TABELA DE LIMPEZA PARA ANDAMENTO */
   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP = 'A'
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP = 'EXPORTACAOTG';

   V_COUNT_COMMIT:= 1;
   COMMIT;
   VERIFTIMEOUT(V_DTHRFINLIMPEZA);

   OPEN C_LISTA;
   LOOP
      FETCH C_LISTA INTO V_CDFILIAL;
      EXIT WHEN C_LISTA%NOTFOUND;

      FOR C_EXPORTACAOTG IN (SELECT ROWID AS LINHA
                               FROM EXPORTACAOTG
                              WHERE CDFILIRECETG = V_CDFILIAL
                                AND DTCONTABILTG BETWEEN V_DTINICIAL AND V_DTFINAL) LOOP

         DELETE EXPORTACAOTG
          WHERE ROWID = C_EXPORTACAOTG.LINHA;

         V_EXCLUI_TG := SQL%ROWCOUNT + V_EXCLUI_TG;

         IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN

            UPDATE TRABPROCLIMPEZA
              SET QTREGEXCLIMPEZA = V_EXCLUI_TG
            WHERE IDLIMPEZA = 'GER'
              AND NMTABELALIMP = 'EXPORTACAOTG';

           /*CONTROLE DE COMMIT HA CADA 1000 REGISTRO DELETEDO  E PARA ATUALIZAR A TELA DE LIMPEZA*/
           V_COUNT_COMMIT:= 1;
           COMMIT;
         ELSE
           V_COUNT_COMMIT:= V_COUNT_COMMIT + 1;
         END IF;
         /*Verifica se a procedure estourou o tempo limite*/
         VERIFTIMEOUT(V_DTHRFINLIMPEZA);
      END LOOP;
   END LOOP;
   CLOSE C_LISTA;

   V_PASSO := 2;

   /* COLOCA O STATUS DA TABELA DE LIMPEZA PARA CONCLUIDO */
   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP = 'C',
          QTREGEXCLIMPEZA = V_EXCLUI_TG,
          DTHRFINLIMPEZA = SYSDATE
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP = 'EXPORTACAOTG';

   /* COLOCA O STATUS DA TABELA DE LIMPEZA PARA ANDAMENTO */
   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP = 'A'
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP = 'EXPORTACAOTI';

   V_COUNT_COMMIT:= 1;
   COMMIT;
   VERIFTIMEOUT(V_DTHRFINLIMPEZA);

   V_PASSO := 3;

   OPEN C_LISTA;
   LOOP
      FETCH C_LISTA INTO V_CDFILIAL;
      EXIT WHEN C_LISTA%NOTFOUND;

      FOR C_EXPORTACAOTI IN (SELECT ROWID AS LINHA
                               FROM EXPORTACAOTI
                              WHERE CDFILIAL2TI = V_CDFILIAL
                                AND DTCONTABILTI BETWEEN V_DTINICIALTI AND V_DTFINALTI) LOOP

         DELETE EXPORTACAOTI
          WHERE ROWID = C_EXPORTACAOTI.LINHA;

         V_EXCLUI_TI := SQL%ROWCOUNT + V_EXCLUI_TI;

         IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN

            UPDATE TRABPROCLIMPEZA
              SET QTREGEXCLIMPEZA = V_EXCLUI_TI
            WHERE IDLIMPEZA = 'GER'
              AND NMTABELALIMP = 'EXPORTACAOTI';

           /*CONTROLE DE COMMIT HA CADA 1000 REGISTRO DELETEDO  E PARA ATUALIZAR A TELA DE LIMPEZA*/
           V_COUNT_COMMIT:= 1;
           COMMIT;
         ELSE
           V_COUNT_COMMIT:= V_COUNT_COMMIT + 1;
         END IF;
         /*Verifica se a procedure estourou o tempo limite*/
         VERIFTIMEOUT(V_DTHRFINLIMPEZA);
      END LOOP;
   END LOOP;
   CLOSE C_LISTA;

   OPEN C_LISTA;
   LOOP
      FETCH C_LISTA INTO V_CDFILIAL;
      EXIT WHEN C_LISTA%NOTFOUND;

      FOR C_EXPORTACAOTI IN (SELECT ROWID AS LINHA
                               FROM USR_SAP_EXPORTACAOTI
                              WHERE CDFILIAL2TI = V_CDFILIAL
                                AND DTCONTABILTI BETWEEN V_DTINICIALTI AND V_DTFINALTI) LOOP

         DELETE USR_SAP_EXPORTACAOTI
          WHERE ROWID = C_EXPORTACAOTI.LINHA;

         V_EXCLUI_TI := SQL%ROWCOUNT + V_EXCLUI_TI;

         IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN

            UPDATE TRABPROCLIMPEZA
              SET QTREGEXCLIMPEZA = V_EXCLUI_TI
            WHERE IDLIMPEZA = 'GER'
              AND NMTABELALIMP = 'EXPORTACAOTI';

           /*CONTROLE DE COMMIT HA CADA 1000 REGISTRO DELETEDO  E PARA ATUALIZAR A TELA DE LIMPEZA*/
           V_COUNT_COMMIT:= 1;
           COMMIT;
         ELSE
           V_COUNT_COMMIT:= V_COUNT_COMMIT + 1;
         END IF;
         /*Verifica se a procedure estourou o tempo limite*/
         VERIFTIMEOUT(V_DTHRFINLIMPEZA);
      END LOOP;
   END LOOP;
   CLOSE C_LISTA;

   V_PASSO := 4;

   /* COLOCA O STATUS DA TABELA DE LIMPEZA PARA CONCLUIDO */
   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP = 'C',
          QTREGEXCLIMPEZA = V_EXCLUI_TI,
          DTHRFINLIMPEZA = SYSDATE
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP = 'EXPORTACAOTI';

   V_COUNT_COMMIT:= 1;
   COMMIT;
   VERIFTIMEOUT(V_DTHRFINLIMPEZA);

   /* COLOCA O STATUS DA TABELA DE LIMPEZA PARA ANDAMENTO */
   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP = 'A'
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP = 'USR_SAP_AUTOFORNE';

   V_COUNT_COMMIT:= 1;
   COMMIT;
   VERIFTIMEOUT(V_DTHRFINLIMPEZA);

   V_PASSO := 5;

   OPEN C_LISTA;
   LOOP
      FETCH C_LISTA INTO V_CDFILIAL;
      EXIT WHEN C_LISTA%NOTFOUND;

      FOR C_USR_SAP_AUTOFORNE IN (SELECT ROWID AS LINHA, IDENTIFIC
                                    FROM USR_SAP_AUTOFORNE
                                   WHERE CENTRO = V_CDFILIAL
                                     AND DTAUTOFORN BETWEEN V_DTINICIAL AND V_DTFINAL) LOOP

         FOR C_USR_SAP_PRAZOPGTAF IN (SELECT ROWID AS LINHA
                                        FROM USR_SAP_PRAZOPGTAF
                                       WHERE CENTRO = V_CDFILIAL
                                         AND IDENTIFIC = C_USR_SAP_AUTOFORNE.IDENTIFIC) LOOP
        
            DELETE USR_SAP_PRAZOPGTAF
             WHERE ROWID = C_USR_SAP_PRAZOPGTAF.LINHA;
         END LOOP;

         FOR C_USR_SAP_ITEMAUTF IN (SELECT ROWID AS LINHA
                                      FROM USR_SAP_ITEMAUTF
                                     WHERE CENTRO = V_CDFILIAL
                                       AND IDENTIFIC = C_USR_SAP_AUTOFORNE.IDENTIFIC) LOOP
        
            DELETE USR_SAP_ITEMAUTF
             WHERE ROWID = C_USR_SAP_ITEMAUTF.LINHA;
         END LOOP;

         DELETE USR_SAP_AUTOFORNE
          WHERE ROWID = C_USR_SAP_AUTOFORNE.LINHA;

         V_EXUSR_SAP_AF := SQL%ROWCOUNT + V_EXUSR_SAP_AF;

         IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN

            UPDATE TRABPROCLIMPEZA
              SET QTREGEXCLIMPEZA = V_EXUSR_SAP_AF
            WHERE IDLIMPEZA = 'GER'
              AND NMTABELALIMP = 'USR_SAP_AUTOFORNE';

           /*CONTROLE DE COMMIT HA CADA 1000 REGISTRO DELETEDO  E PARA ATUALIZAR A TELA DE LIMPEZA*/
           V_COUNT_COMMIT:= 1;
           COMMIT;
         ELSE
           V_COUNT_COMMIT:= V_COUNT_COMMIT + 1;
         END IF;
         /*Verifica se a procedure estourou o tempo limite*/
         VERIFTIMEOUT(V_DTHRFINLIMPEZA);
      END LOOP;
   END LOOP;
   CLOSE C_LISTA;

   /* COLOCA O STATUS DA TABELA DE LIMPEZA PARA CONCLUIDO */
   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP = 'C',
          QTREGEXCLIMPEZA = V_EXUSR_SAP_AF,
          DTHRFINLIMPEZA = SYSDATE
    WHERE IDLIMPEZA = 'GER'
      AND NMTABELALIMP = 'USR_SAP_AUTOFORNE';

   V_COUNT_COMMIT:= 1;
   COMMIT;
   VERIFTIMEOUT(V_DTHRFINLIMPEZA);

    UPDATE TRABLIMPEZA
      SET IDSTATUSLIMPEZA = 'C', IDLIMPEZACONCERRO = 'N'
    WHERE IDLIMPEZA = 'GER';

   V_COUNT_COMMIT:= 1;
   COMMIT;
   VERIFTIMEOUT(V_DTHRFINLIMPEZA);

   INSERT INTO LOGLIMPEZA
     (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES
     ('Tabelas Especificas', 'USR_SAP_NOTAFISCAL', SYSDATE, 'Especifico', V_DTFINAL, 'USR_SAP_NOTAFISCAL', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUINF_SAP);

   INSERT INTO LOGLIMPEZA
     (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES
     ('Tabelas Especificas', 'EXPORTACAOTG', SYSDATE, 'Especifico', V_DTFINAL, 'EXPORTACAOTG', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUI_TG);

   INSERT INTO LOGLIMPEZA
     (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES
     ('Tabelas Especificas', 'EXPORTACAOTI', SYSDATE, 'Especifico', V_DTFINAL, 'EXPORTACAOTI', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUI_TI);

   INSERT INTO LOGLIMPEZA
     (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES
     ('Tabelas Especificas', 'USR_SAP_AUTOFORNE', SYSDATE, 'Especifico', V_DTFINAL, 'USR_SAP_AUTOFORNE', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXUSR_SAP_AF);

   COMMIT;
EXCEPTION
WHEN OTHERS THEN
   V_ERR0R := SQLERRM(SQLCODE);

   IF INSTR(V_ERR0R, 'TIMEOUT - EXCECAO PROPOSITAL TEKNISA') = 0 THEN
      UPDATE TRABLIMPEZA
         SET IDSTATUSLIMPEZA = 'C', IDLIMPEZACONCERRO = 'S'
       WHERE IDLIMPEZA = 'GER';

      COMMIT;
   ELSE
       UPDATE TRABLIMPEZA
          SET IDSTATUSLIMPEZA = 'P'
        WHERE IDLIMPEZA = 'GER';
   END IF;

   IF (V_EXCLUINF_SAP > 0) THEN
      INSERT INTO LOGLIMPEZA
        (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES
        ('Tabelas Especificas', 'USR_SAP_NOTAFISCAL', SYSDATE, 'Especifico', V_DTFINAL, 'USR_SAP_NOTAFISCAL', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUINF_SAP);
   END IF;

   IF (V_EXCLUI_TG > 0) THEN
      INSERT INTO LOGLIMPEZA
        (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES
        ('Tabelas Especificas', 'EXPORTACAOTG', SYSDATE, 'Especifico', V_DTFINAL, 'EXPORTACAOTG', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUI_TG);
   END IF;

   IF (V_EXCLUI_TI > 0) THEN
      INSERT INTO LOGLIMPEZA
        (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES
        ('Tabelas Especificas', 'EXPORTACAOTI', SYSDATE, 'Especifico', V_DTFINAL, 'EXPORTACAOTI', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUI_TI);
   END IF;

   IF (V_EXUSR_SAP_AF > 0) THEN
      INSERT INTO LOGLIMPEZA
        (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES
        ('Tabelas Especificas', 'USR_SAP_AUTOFORNE', SYSDATE, 'Especifico', V_DTFINAL, 'USR_SAP_AUTOFORNE', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXUSR_SAP_AF);
   END IF;

   COMMIT;

   RAISE_APPLICATION_ERROR (-20101, 'PASSO : ' || V_PASSO || '   -   ' || V_ERR0R);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GRS_LIMPEZA_TAB_ESPEC','6.45.009'); END;
/
